//TEST CASE PASS IN GPU_VERIFY. IT IS NOT VERIFY ARRAY BOUNDS VIOLATION

#include <stdio.h>
#include <cuda.h>
#include <cuda_runtime_api.h>
#include <assert.h>
#define N 2//64

__global__ void foo(int* p) {

  int* q;

  q = p + 1;
  //printf(" %d; ", q[threadIdx.x]);

  p[threadIdx.x] = q[threadIdx.x];
  //printf ("%d; ", q[threadIdx.x]);

}

int main() {
	int *c;
	int *d;
	int *dev_c;

	c = (int*)malloc(N*sizeof(int));
	d = (int*)malloc(N*sizeof(int));

	for (int i = 0; i < N; ++i)
		c[i] = rand() %10 + 1;

	/*for (int i = 0; i < N; ++i)
		printf(" %d; ", c[i]);

	printf ("\n");
*/
	cudaMalloc((void**)&dev_c, N*sizeof(int));

	cudaMemcpy(dev_c, c, N*sizeof(int), cudaMemcpyHostToDevice);

	//foo<<<1, N>>>(dev_c);
	verify_kernel(foo,1,N,dev_c);	

	cudaMemcpy(d, dev_c, N*sizeof(int), cudaMemcpyDeviceToHost);

	//printf ("\n");
	for (int i = 0; i < N; ++i){
	//	printf(" %d; ", d[i]);
		assert(d[i]==c[i+1]);
	}

	//printf("\n");

	free(c);
	cudaFree(dev_c);

	   return 0;
}
