//pass
//--blockDim=32 --gridDim=2

__global__ void foo() {
    __threadfence();
}


int main(){

	//It's necessary to set a device variable (dev_a), although it was not used, otherwise the kernel will not be launched.
	int a = 5;
	int *dev_a;

	cudaMalloc ((void**) &dev_a, sizeof(int));

	cudaMemcpy(dev_a, &a, sizeof(int),cudaMemcpyHostToDevice);

	foo<<<2,32>>>();

	cudaMemcpy(&a,dev_a,sizeof(int),cudaMemcpyDeviceToHost);

	cudaFree(&dev_a);

	return 0;

}
