#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

//pass
//--blockDim=10 --gridDim=64 --no-inline

#include "cuda.h"
#include "cuda_runtime_api.h"

__global__ void foo() {

  __shared__ int A[10][10];
  A[threadIdx.y][threadIdx.x] = 2;
//  printf ("%d ", A[threadIdx.y][threadIdx.x]);
  assert(A[threadIdx.y][threadIdx.x]==2);
}

int main(){

	dim3 dimBlock(2,2);
	//foo<<<10, N>>>();
	verify_kernel(foo, 1, dimBlock);
	cudaThreadSynchronize();
}

