//gpuverify --blockDim=4 --gridDim=1 kernel.cu
//pass: analisando a atribuio dentro do 'if', requer inicializao correta do 'i' na main() , com 1 ou 2, obrigatoriamente
/*#include <stdio.h>
#include "cuda.h"
#include "cuda_runtime_api.h"
#define N 4 //64
*/

//#include <assert.h>

__device__ float multiplyByTwo(float *v, unsigned int tid) {

    return v[tid] * 2.0f;
}

__device__ float divideByTwo(float *v, unsigned int tid) {

    return v[tid] * 0.5f;
}

typedef float(*funcType)(float*, unsigned int);

__global__ void foor(float *v, unsigned int size, unsigned int i) {

    unsigned int tid = blockIdx.x * blockDim.x + threadIdx.x;
    funcType f;

		__assert(i == 1 || i == 2);
		
    if (i == 1)
      f = multiplyByTwo;
    else if (i == 2)
      f = divideByTwo;
    else
      f = NULL;

    if (tid < size)
    {
        float x = (*f)(v, tid);
        x += multiplyByTwo(v, tid);
		v[tid] = x;
    }
}
