//time gpuverify --blockDim=1 --gridDim=1 kernel.cu --time
//pass: analisa funes da biblioteca math_functions e atribuio para ponteiro de funo e o suporte para biblioteca stdio.h
//blockDim=1024 --gridDim=1 --no-inline

#include <stdio.h>

typedef double(*funcType)(double);

__device__ double bar(double x) {
  return sin(x);
}

__global__ void foo(double x, int i)
{
  funcType f;

  if (i == 0)
    f = bar;
  else
    f = cos;

  double z = f(x);

  printf("z: %f ", z);
}
