//time gpuverify kernel.cu --blockDim=2 --gridDim=1 --time

//#define N 2//8

#define tid (blockIdx.x * blockDim.x + threadIdx.x)

__device__ float multiplyByTwo(float *v, unsigned int index)
{
    return v[index] * 2.0f;
}

__device__ float divideByTwo(float *v, unsigned int index)
{
    return v[index] * 0.5f;
}

typedef float(*funcType)(float*, unsigned int);

__global__ void foo(float *v)
{
    funcType f = (funcType)3; // it's a null pointer
    v[tid] = (*f)(v, tid);
}

