#include <stdio.h>
#include "cuda.h"
#include <assert.h>
#include <cuda_runtime_api.h>

#define N 2

__global__ void foo(int	*p, int *ptr_a) {

	ptr_a = p + threadIdx.x;

//	assert(*ptr_a == 1);
//	assert(*ptr_a == (2 + threadIdx.x) );

}

int main() {
	int *c;
	int *dev_c;
	int *a;
	int *dev_a;


	c = (int*)malloc(N*sizeof(int));
	a = (int*)malloc(N*sizeof(int));

	for (int i = 0; i < N; ++i)
		c[i] = 2/* rand() %10+1(*/;
//		c[i] = rand() %10+1;

	assert(c[0] == 2);
	assert(c[1] == 2);

	for (int i = 0; i < N; ++i)
		printf(" %d; ", c[i]);
	printf("\n");

	cudaMalloc((void**)&dev_c, N*sizeof(int));
	cudaMalloc((void**)&dev_a, N*sizeof(int));

	cudaMemcpy(dev_c, c, N*sizeof(int), cudaMemcpyHostToDevice);

//	foo<<<1, N>>>(dev_c, dev_a);
	verify_kernel(foo,1,N,dev_c, dev_a);

	cudaMemcpy(a, dev_a, N*sizeof(int), cudaMemcpyDeviceToHost);

//	assert(a[0]==2);
//	assert(a[1]==3);
//	assert(a[0]==0);
 
	printf ("\n");

	for (int i = 0; i < N; ++i){
			printf(" %d; ", a[i]);
//			assert(a[i]==c[i]+i);
	}

	free(c);
	cudaFree(dev_c);

	return 0;
}

