// time gpuverify --blockDim=3 --gridDim=1 kernel.cu --time
//pass
//--blockDim=32 --gridDim=64 --no-inline
/*
#include <cuda.h>
#include <cuda_runtime_api.h>
#include <stdio.h>
#include <assert.h>
*/
#define N 3//32

__device__ void f(float *odata, int* ai) {
    int thid = threadIdx.x;
    *ai = thid;
    odata[*ai] = 2*threadIdx.x;
}

__global__ void k(float *g_odata) {
    int ai;
    f(g_odata,&ai);
}
