//time gpuverify kernel.cu --blockDim=[2,2,2] --gridDim=1 --time
/*#include <stdio.h>
#include <vector_types.h>
#include <assert.h>
#include <cuda.h>
#include <cuda_runtime_api.h>
*/
#define N 8

__device__  double C[2][2][2];

__device__ int index (int a, int b, int c){
	return 4*a + 2*b + c;
}

__global__ void foo(double *H) {

	int idx = index (threadIdx.x,threadIdx.y,threadIdx.z);

	H[idx] = C[threadIdx.x][threadIdx.y][threadIdx.z];
}
